<?php
################################################################################
# @Name : ticket_asset_type.php
# @Description : send asset of selected asset type
# @Call : ./ticket.php
# @Parameters :  
# @Author : Flox
# @Create : 06/10/2022
# @Update : 06/10/2022
# @Version : 3.2.28
################################################################################

//security check
if(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') 
{
    //db connection
    require('../connect.php');

    //init and secure POST var
    require('../core/init_post.php');

    //switch SQL MODE to allow empty values
    $db->exec('SET sql_mode = ""');

    //load parameters table
    $qry=$db->prepare("SELECT * FROM `tparameters`");
    $qry->execute();
    $rparameters=$qry->fetch();
    $qry->closeCursor();

    //display error parameter
    if($rparameters['debug']) {
        ini_set('display_errors', 'On');ini_set('display_startup_errors', 'On');ini_set('html_errors', 'On');error_reporting(E_ALL);
    } else {
        ini_set('display_errors', 'Off');ini_set('display_startup_errors', 'Off'); ini_set('html_errors', 'Off');error_reporting(E_ALL & ~E_DEPRECATED & ~E_STRICT);
    }

    //init asset array
    $asset_arr=array();

    $asset_arr[] = array("id" => 0, "netbios" => 'Aucun', "selected" => '');

    //put each db value in array 
    $qry=$db->prepare("SELECT `id`,`netbios`,`user` FROM `tassets` WHERE `type` LIKE :asset_type ORDER BY `netbios`");
    $qry->execute(array('asset_type' => $_POST['TypeId']));
    while($asset=$qry->fetch()) 
    {
        $asset_arr[] = array("id" => $asset['id'], "netbios" => $asset['netbios'], "selected" => '');
    }
    $qry->closeCursor();

    //return array
    echo json_encode($asset_arr);

    //close database access
	$db = null;
} else {
	echo json_encode(array("status" => "error","message" => 'Unauthorized access'));
}
?>